Index: /GTP/trunk/Lib/Vis/Preprocessing/scripts/gi_final.sh
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/scripts/gi_final.sh	(revision 2350)
+++ /GTP/trunk/Lib/Vis/Preprocessing/scripts/gi_final.sh	(revision 2364)
@@ -7,20 +7,20 @@
 TARGET=release
 
-PROGRAM=../bin/$TARGET/Preprocessor2.exe
-#PROGRAM=../bin/$TARGET/Preprocessor_old.exe
+PROGRAM=../bin/$TARGET/Preprocessor.exe
 #PROGRAM=../bin/$TARGET/Preprocessor_itl.exe
 
 EXT=obj
-SCENE=vienna_cropped
-SCENE_PATH=../data/vienna
 
-#SCENE=arena-high-lods
-#SCENE_PATH=../data/Arena
+#SCENE=vienna_cropped
+#SCENE_PATH=../data/vienna
 
-SCENE=soda
-SCENE_PATH=../data/soda
+SCENE=arena-high-lods
+SCENE_PATH=../data/Arena
 
-ENVIRONMENT=gi_final.env
-LOG_PREFIX=../scripts/tests/gi/$SCENE-test
+#SCENE=soda
+#SCENE_PATH=../data/soda
+
+ENVIRONMENT=gi_final2.env
+LOG_PREFIX=../scripts/tests/gi/$SCENE
 
 echo "starting $TARGET mode for $SCENE scene ($PROGRAM)"
@@ -28,8 +28,82 @@
 SCENE_FILENAME=$SCENE_PATH/$SCENE.$EXT
 
+OBJ_WEIGHT=70
+
+#######################################################
+
+NODES=30000
+USE_HEUR=false
+METHOD=seq-$NODES-$USE_HEUR-$OBJ_WEIGHT
+ 
+echo "$SCENE $METHOD"
+$PROGRAM $ENVIRONMENT \
+ -scene_filename=$SCENE_FILENAME \
+ -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
+ -view_cells_merge_stats=$LOG_PREFIX-$METHOD-mergeStats.log \
+ -view_cells_filename=$LOG_PREFIX-$METHOD-viewcells.xml.gz \
+ -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
+ -bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
+ -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
+ -hierarchy_construction_type=0 \
+ -view_cells_triangle_weight=1.0 \
+ -view_cells_object_weight=$OBJ_WEIGHT \
+ -vsp_use_cost_heuristics=$USE_HEUR \
+ -bvh_term_max_leaves=$NODES
+
+sh movefiles.sh $LOG_PREFIX-$METHOD
+
+
+#######################################################
+
+NODES=3000
+USE_HEUR=false
+METHOD=seq-$NODES-$USE_HEUR-$OBJ_WEIGHT
+ 
+echo "$SCENE $METHOD"
+$PROGRAM $ENVIRONMENT \
+ -scene_filename=$SCENE_FILENAME \
+ -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
+ -view_cells_merge_stats=$LOG_PREFIX-$METHOD-mergeStats.log \
+ -view_cells_filename=$LOG_PREFIX-$METHOD-viewcells.xml.gz \
+ -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
+ -bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
+ -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
+ -hierarchy_construction_type=0 \
+ -view_cells_triangle_weight=1.0 \
+ -view_cells_object_weight=$OBJ_WEIGHT \
+ -vsp_use_cost_heuristics=$USE_HEUR \
+ -bvh_term_max_leaves=$NODES
+
+sh movefiles.sh $LOG_PREFIX-$METHOD
+
+#######################################################
+
+NODES=1000
+USE_HEUR=false
+METHOD=seq-$NODES-$USE_HEUR-$OBJ_WEIGHT
+ 
+echo "$SCENE $METHOD"
+$PROGRAM $ENVIRONMENT \
+ -scene_filename=$SCENE_FILENAME \
+ -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
+ -view_cells_merge_stats=$LOG_PREFIX-$METHOD-mergeStats.log \
+ -view_cells_filename=$LOG_PREFIX-$METHOD-viewcells.xml.gz \
+ -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
+ -bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
+ -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
+ -hierarchy_construction_type=0 \
+ -view_cells_triangle_weight=1.0 \
+ -view_cells_object_weight=$OBJ_WEIGHT \
+ -vsp_use_cost_heuristics=$USE_HEUR \
+ -bvh_term_max_leaves=$NODES
+
+sh movefiles.sh $LOG_PREFIX-$METHOD
+
+
 #######################################################
 
 USE_HEUR=false
-METHOD=int-$USE_HEUR
+
+METHOD=int-$USE_HEUR-$OBJ_WEIGHT-nosah
 
 echo "$SCENE $METHOD"
@@ -41,5 +115,5 @@
   -view_cells_filename=$LOG_PREFIX-$METHOD-viewcells.xml.gz \
   -view_cells_triangle_weight=1.0 \
-  -view_cells_object_weight=0.0 \
+  -view_cells_object_weight=$OBJ_WEIGHT \
   -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
   -bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
@@ -48,9 +122,35 @@
   -hierarchy_construction_min_avg_rays_per_object=0 \
   -hierarchy_construction_max_avg_rays_per_object=0 \
-  -bvh_use_sah=true \
+  -bvh_use_sah=false \
   -vsp_use_cost_heuristics=$USE_HEUR
 
 sh movefiles.sh $LOG_PREFIX-$METHOD
 
+
+#######################################################
+
+USE_HEUR=false
+
+METHOD=int-$USE_HEUR-$OBJ_WEIGHT-nosah
+
+echo "$SCENE $METHOD"
+$PROGRAM $ENVIRONMENT \
+  -scene_filename=$SCENE_FILENAME \
+  -view_cells_sampling_type=object_directional \
+  -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
+  -view_cells_merge_stats=$LOG_PREFIX-$METHOD-mergeStats.log \
+  -view_cells_filename=$LOG_PREFIX-$METHOD-viewcells.xml.gz \
+  -view_cells_triangle_weight=1.0 \
+  -view_cells_object_weight=$OBJ_WEIGHT \
+  -vsp_subdivision_stats=$LOG_PREFIX-$METHOD-vsp-subdivisionStats.log \
+  -bvh_subdivision_stats=$LOG_PREFIX-$METHOD-bvh-subdivisionStats.log \
+  -hierarchy_subdivision_stats=$LOG_PREFIX-$METHOD-hierarchy-subdivisionStats.log \
+  -hierarchy_construction_type=2 \
+  -hierarchy_construction_min_avg_rays_per_object=0 \
+  -hierarchy_construction_max_avg_rays_per_object=0 \
+  -bvh_use_sah=false \
+  -vsp_use_cost_heuristics=$USE_HEUR
+
+sh movefiles.sh $LOG_PREFIX-$METHOD
 
 
@@ -59,8 +159,8 @@
 NODES=60000
 USE_HEUR=false
-METHOD=seq-$NODES-$USE_HEUR
+METHOD=seq-$NODES-$USE_HEUR-$OBJ_WEIGHT
  
 #echo "$SCENE $METHOD"
-# $PROGRAM $ENVIRONMENT \
+#$PROGRAM $ENVIRONMENT \
  -scene_filename=$SCENE_FILENAME \
  -view_cells_evaluation_stats_prefix=$LOG_PREFIX-$METHOD \
@@ -72,5 +172,5 @@
  -hierarchy_construction_type=0 \
  -view_cells_triangle_weight=1.0 \
- -view_cells_object_weight=50.0 \
+ -view_cells_object_weight=$OBJ_WEIGHT \
  -vsp_use_cost_heuristics=$USE_HEUR \
  -bvh_term_max_leaves=$NODES
Index: /GTP/trunk/Lib/Vis/Preprocessing/scripts/gi_final.env
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/scripts/gi_final.env	(revision 2350)
+++ /GTP/trunk/Lib/Vis/Preprocessing/scripts/gi_final.env	(revision 2364)
@@ -21,7 +21,7 @@
 	loadMeshes false
 	# internal raycaster
-	#rayCastMethod 0  
+	rayCastMethod 0  
 	# intel raycaster
-	rayCastMethod 1
+	#rayCastMethod 1
 	exportVisibility false
 	applyVisibilityFilter false
@@ -179,6 +179,6 @@
 	
 	Evaluation {
-		samples         6000000
-		samplesForStats 2000000
+		samples         80000000
+		samplesForStats 40000000
 
 		samplesPerPass  500000
@@ -231,5 +231,5 @@
 	Construction {		
 		renderCostDecreaseWeight 0.999
-#		renderCostDecreaseWeight 1.0
+		#renderCostDecreaseWeight 1.0
 	}
 
@@ -264,5 +264,5 @@
 	Construction {
 
-		samples 100000
+		samples 5000000
 
 		# type 0 = sequential computation, 1 = interleaved, 2 = gradient
@@ -286,8 +286,8 @@
 	Termination {
 		# maximal number of leaves
-		maxLeaves 10000
+		maxLeaves 100000
 		# maximal memory in MB
 #		maxMemory 4
-		maxMemory 25
+		maxMemory 20
 		# minimum ratio of global cost decrease
 		minGlobalCostRatio -1