Index: /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.h	(revision 2342)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.h	(revision 2380)
@@ -246,5 +246,5 @@
 	virtual bool IsLeaf() const = 0;
 
-	static bool SmallerPvs(const ViewCell *a, const ViewCell *b) 
+	inline bool SmallerPvs(const ViewCell *a, const ViewCell *b) 
 	{
 		// HACK: take scalar value because pvs may not have been stored properly
@@ -256,15 +256,15 @@
 	}
 
-	static bool GreaterOrEqualPvs(const ViewCell *a, const ViewCell *b) 
+	inline bool GreaterOrEqualPvs(const ViewCell *a, const ViewCell *b) 
 	{
 		return !SmallerPvs(a, b);
 	}
 
-	static bool SmallerRenderCost(const ViewCell *a, const ViewCell *b) 
+	inline bool SmallerRenderCost(const ViewCell *a, const ViewCell *b) 
 	{
 		return a->GetRenderCost() < b->GetRenderCost();
 	}
 
-	static bool LargerRenderCost(const ViewCell *a, const ViewCell *b) 
+	inline bool LargerRenderCost(const ViewCell *a, const ViewCell *b) 
 	{
 		return a->GetRenderCost() > b->GetRenderCost();
Index: /GTP/trunk/Lib/Vis/GtpVisibility.sln
===================================================================
--- /GTP/trunk/Lib/Vis/GtpVisibility.sln	(revision 2353)
+++ /GTP/trunk/Lib/Vis/GtpVisibility.sln	(revision 2380)
@@ -20,12 +20,4 @@
 		{101A7691-74F3-48B4-96A3-CF35578F5900} = {101A7691-74F3-48B4-96A3-CF35578F5900}
 		{EABCE292-D598-4600-A1C9-2591E7D62FDA} = {EABCE292-D598-4600-A1C9-2591E7D62FDA}
-		{7319E499-473D-4CE5-9983-725D6E68A55D} = {7319E499-473D-4CE5-9983-725D6E68A55D}
-		{7319E499-473D-4CE5-9983-725D6E68A55D} = {7319E499-473D-4CE5-9983-725D6E68A55D}
-		{7319E499-473D-4CE5-9983-725D6E68A55D} = {7319E499-473D-4CE5-9983-725D6E68A55D}
-		{7319E499-473D-4CE5-9983-725D6E68A55D} = {7319E499-473D-4CE5-9983-725D6E68A55D}
-		{7319E499-473D-4CE5-9983-725D6E68A55D} = {7319E499-473D-4CE5-9983-725D6E68A55D}
-		{7319E499-473D-4CE5-9983-725D6E68A55D} = {7319E499-473D-4CE5-9983-725D6E68A55D}
-		{7319E499-473D-4CE5-9983-725D6E68A55D} = {7319E499-473D-4CE5-9983-725D6E68A55D}
-		{7319E499-473D-4CE5-9983-725D6E68A55D} = {7319E499-473D-4CE5-9983-725D6E68A55D}
 	EndProjectSection
 EndProject
@@ -54,4 +46,5 @@
 Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "ObjReader", "OnlineCullingCHC\ObjReader\src\ObjReader.vcproj", "{5776B40B-5FCE-46D5-8F7C-3912E24E0638}"
 	ProjectSection(ProjectDependencies) = postProject
+		{EABCE292-D598-4600-A1C9-2591E7D62FDA} = {EABCE292-D598-4600-A1C9-2591E7D62FDA}
 	EndProjectSection
 EndProject
@@ -111,8 +104,8 @@
 		{EABCE292-D598-4600-A1C9-2591E7D62FDA}.Release Internal.ActiveCfg = Release Internal|Win32
 		{EABCE292-D598-4600-A1C9-2591E7D62FDA}.Release Internal.Build.0 = Release Internal|Win32
-		{EABCE292-D598-4600-A1C9-2591E7D62FDA}.Release_noqt.ActiveCfg = Release_noqt|Win32
-		{EABCE292-D598-4600-A1C9-2591E7D62FDA}.Release_noqt.Build.0 = Release_noqt|Win32
-		{EABCE292-D598-4600-A1C9-2591E7D62FDA}.Release_qt.ActiveCfg = Release_Qt|Win32
-		{EABCE292-D598-4600-A1C9-2591E7D62FDA}.Release_qt.Build.0 = Release_Qt|Win32
+		{EABCE292-D598-4600-A1C9-2591E7D62FDA}.Release_noqt.ActiveCfg = release_noqt|Win32
+		{EABCE292-D598-4600-A1C9-2591E7D62FDA}.Release_noqt.Build.0 = release_noqt|Win32
+		{EABCE292-D598-4600-A1C9-2591E7D62FDA}.Release_qt.ActiveCfg = Release_qt|Win32
+		{EABCE292-D598-4600-A1C9-2591E7D62FDA}.Release_qt.Build.0 = Release_qt|Win32
 		{69BC58F0-C7EB-4B43-B782-B6F047EF0528}.Debug.ActiveCfg = Debug|Win32
 		{69BC58F0-C7EB-4B43-B782-B6F047EF0528}.Debug.Build.0 = Debug|Win32
@@ -121,8 +114,8 @@
 		{69BC58F0-C7EB-4B43-B782-B6F047EF0528}.Release Internal.ActiveCfg = Release Internal|Win32
 		{69BC58F0-C7EB-4B43-B782-B6F047EF0528}.Release Internal.Build.0 = Release Internal|Win32
-		{69BC58F0-C7EB-4B43-B782-B6F047EF0528}.Release_noqt.ActiveCfg = Release_noqt|Win32
-		{69BC58F0-C7EB-4B43-B782-B6F047EF0528}.Release_noqt.Build.0 = Release_noqt|Win32
-		{69BC58F0-C7EB-4B43-B782-B6F047EF0528}.Release_qt.ActiveCfg = Release_Qt|Win32
-		{69BC58F0-C7EB-4B43-B782-B6F047EF0528}.Release_qt.Build.0 = Release_Qt|Win32
+		{69BC58F0-C7EB-4B43-B782-B6F047EF0528}.Release_noqt.ActiveCfg = release_noqt|Win32
+		{69BC58F0-C7EB-4B43-B782-B6F047EF0528}.Release_noqt.Build.0 = release_noqt|Win32
+		{69BC58F0-C7EB-4B43-B782-B6F047EF0528}.Release_qt.ActiveCfg = Release_qt|Win32
+		{69BC58F0-C7EB-4B43-B782-B6F047EF0528}.Release_qt.Build.0 = Release_qt|Win32
 		{248F19A6-2FE0-4F5D-8928-E0EA10609887}.Debug.ActiveCfg = Debug|Win32
 		{248F19A6-2FE0-4F5D-8928-E0EA10609887}.Debug.Build.0 = Debug|Win32